#-- Calculation of activation enthalpy using two kinetic constants

import math

#--- Ras-GNP state 1-2 equilibrium:  Spoerner #3607, Table 4
#k1=250.0  # /s
#k2=700.0

#T1=15.0  # Deg C
#T2=25.0


#-- isomerization step in wt HRas {Sydor, 1998 #3849}
k1=780.0  # /s
k2=1380.0

T1=10.0  # Deg C
T2=15.0


#---- test numbers should give 52 kJ/mol
k1=750.0  # /s
k2=1082.0
T1=17.0  # Deg C
T2=22.0

#--- temperature where you want to calculate rate at
T3=25



#-- constants
T0=273.2
R=8.31 # J/mol K

Ha=R *math.log(k1/k2)/ ( ( 1/(T0+T2) - 1/(T0+T1)))

print "Activation enthalpy for \n%f /s at %f C going to  \n%f /s at %f C\nis %f J/mol" % (
k1,T1,k2,T2,Ha)


k3=k1*math.exp(Ha * (1/(T0+T1) - 1/(T0+T3))/R)
print "Calculated rate for %f Dec C will be %f /s " % (T3,k3)
