

# general conditional values
YES,NO=1,0

# initial model parameters positions in the .ini file
INITval, MINval, MAXval, GRIDsteps= 0,1,2,3


# the modes of 'mfinput' file generation and 'mfout' loading
(SINGLE_MODEL,FTEST,TENSOR_OPT,
                    LAST_RUN    # final run of low S2 residues with optimized tensor
                    )=(11,22,33,44)  # not to confuse with columns



####################################################################
#------- positions in the 'Modelfree_Output.reslist' ---------------
# --- from reading of mfout files

MFINPUT_COLUMNS=13  # total number of columns (below)

(# model fitted parameters
 S2S, S2Sstddev, S2F, S2Fstddev,TE, TEstddev, REX, REXstddev, 
 GAMMA, GAMMAcritical, # SSE, SSE simulated at p
 FVALUE, FVALUEcritical, #  F-test value, F value simulated at p
 MODEL_USED     # model used by modelFree
 )=range(MFINPUT_COLUMNS)




####################################################################
#------------------- Main fitting data storage ----------------------

# class Fitting_Parameters keys for parameters of the Tensor and tm
FITTEDval="fitted value"
STARTval="starting value"
SIMerror="simulated error"

# columns for Fitting_Parameters objects
FITTED_PARS_COLUMNS=17
(MODEL,
 S2Sprev, S2Scurr,  S2Ssimerr,
 S2Fprev, S2Fcurr,  S2Fsimerr,
 TEprev,  TEcurr,   TEsimerr,
 REXprev, REXcurr,  REXsimerr, GAMMAfitted,
 FTESTquality,  # FVALUEcritical/FVALUE  for M1,2,3 
 GAMMAquality,  # GAMMA/GAMMAcritical for M1,2,3
 COMMENT)=range(FITTED_PARS_COLUMNS)
# for nice-looking printout
fitted_columns={
    MODEL   :   "MODEL"   ,
    S2Sprev :   "S2Sprev" ,
    S2Scurr :   "S2Scurr"  ,
    S2Ssimerr:  "S2Ssimerr" ,
    S2Fprev :   "S2Fprev" ,
    S2Fcurr :   "S2Fcurr" ,
    S2Fsimerr:  "S2Fsimerr" ,
    TEprev   :  "TEprev",
    TEcurr   :  "TEcurr" ,
    TEsimerr :  "TEsimerr" ,
    REXprev  :  "REXprev",
    REXcurr  :  "REXcurr",
    REXsimerr   :   "REXsimerr" ,
    GAMMAfitted :   "GAMMAfitted" ,
    FTESTquality :  "FTESTquality",
    GAMMAquality :  "GAMMAquality",
    COMMENT      :  "COMMENT" 
    }




# ------- models numbers --------
M1,M2,M3,M4,M5,UNASSIGNED=(1,2,3,4,5,0)


#--------- Used bu make_mfmodel()
model_matrix={
    M1   :[ 0, 0, 0, 1, 0, 0 ],
    M2   :[ 0, 0, 0, 1, 1, 0 ],
    M3   :[ 0, 0, 0, 1, 0, 1 ],
    M4   :[ 0, 0, 0, 1, 1, 1 ],
    M5   :[ 0, 0, 1, 1, 1, 0 ]
    }

#---- used by ModelFree_Output
# note leading '0'
model_codes={
    "0000100" :M1,
    "0000110" :M2,
    "0000101" :M3,
    "0000111" :M4, 
    "0001110" :M5,
    }



# mode for model parameters fitting (not tensor!!!)
(USE_INIT,USE_FITTED)="init","fitted"   # which parameters to start fitting from
