#!/usr/bin/env python
import os, sys, string, pickle
import MFselect_lib_2
import mylib
from MFselect_constants import *
import xmgr
doc="""
====================== MFselect_compare.py ======================

This is a utility for extraction of S2 data from MFselect results

Uses *.pickled files from MFselect

Usage: MFselect_extract_S2.py fname 

================================================================
"""
#------------------------------------------------------------
def remove_unassigned(data):
    'delete unassigned entries'
    to_remove=[]
    for res in data.Residue_list.get_keys():
        if data.Residue_list[res][MODEL]==UNASSIGNED: to_remove.append(res)

    print data.Residue_list.name, ": removing unassigned: ", to_remove
    for res in to_remove:
        del data.Residue_list[res]




if len(sys.argv)<2:
    print doc
    sys.exit()


# Pickled result names:
fname=sys.argv[1]


#-- open file ---
print "\n\nReading data from '%s'" % fname
db=mylib.open_file(fname,'r')
data=pickle.load(db)

# set proper names
data.Residue_list.set_name(fname+"S2")


#remove unassigned residues
remove_unassigned(data)

s2s_data=data.Residue_list.to_xmgr(Xcol="Key", Ycol=S2Scurr, dYcol=S2Ssimerr)

outfname=fname+".S2s"
outfile=open(outfname,'w')
for line in s2s_data:
    outfile.write("%s %s %s\n" %(line[0],line[1],line[2]))
    #print "%s %s %s" %(line[0],line[1],line[2])

outfile.close()
print "'%s' is written." %  outfname
