#!/usr/bin/env python
import os, sys, string, pickle
import MFselect_lib_2
import mylib
from MFselect_constants import *
import xmgr
doc="""
====================== MFselect_extract_model_S2.py ======================
by Evgenii Kovrigin, 12/1/05

This is a utility for extraction of  model number, S2 and its
simulated error from pickled results of MFselect


Usage: MFselect_extract_S2.py fname 

================================================================
"""
#------------------------------------------------------------
def remove_unassigned(data):
    'delete unassigned entries'
    to_remove=[]
    for res in data.Residue_list.get_keys():
        if data.Residue_list[res][MODEL]==UNASSIGNED: to_remove.append(res)

    print data.Residue_list.name, ": removing unassigned: ", to_remove
    for res in to_remove:
        del data.Residue_list[res]




if len(sys.argv)<2:
    print doc
    sys.exit()


# Pickled result names:
fname=sys.argv[1]


#-- open file ---
print "\n\nReading data from '%s'" % fname
db=mylib.open_file(fname,'r')
data=pickle.load(db)

# set proper names
data.Residue_list.set_name(fname+"S2")


#remove unassigned residues
remove_unassigned(data)

print data.Residue_list

outfname=fname+".model_S2s.txt"
outfile=open(outfname,'w')
for resnum in data.Residue_list.get_keys():
    outfile.write("%s\t%s\t%s\t%s\n" %(resnum,
                                   data.Residue_list[resnum][MODEL],
                                   data.Residue_list[resnum][ S2Scurr],
                                   data.Residue_list[resnum][ S2Ssimerr]
                                   ))


outfile.close()
print "'%s' is written." %  outfname
