#!/usr/bin/env python
import os,sys,string, time, pickle
import MFselect_lib_2 as MFselect_lib
import residues
import mylib
import keyfile
import copy
from MFselect_constants import *
from MFselect_flowcharts import *
from  MFselect_checklist_before_run import *

import colors
from colors import *
#-- to make it portable: use color only when requested explicitly
if '-color' in sys.argv: colors.COLOR=ON


#-------------------------------------------------------
def full_run(inifile):
    """
    Do model selection and model parameters calculations
    without use of that trick with NON-exhanging residues
    """
    
    
    print "******** FULL RUN **********************************"

    # create storage place for fitting parameters
    fitted=MFselect_lib.Fitting_Parameters("full_run_optimization")
    # load initial parameters and experimental data
    init=MFselect_lib.Initial_Parameters(inifile, fitted)
    

    flow_chart(init, fitted, mode=USE_INIT, do_optimization=YES)

#--------------------------------------------------------



 
#--------------------------------------------------
# load initial parameters
full="MFselect_ini.full"


t1=time.time()
cprint(INV_GREEN,
"\nFull run: no 'non-exchange datasets' trick!\n")

#--------- ModelFree ----
full_run(full)


#----- statistics -----
t2=time.time()
iter_time=t2-t1
cprint(BLINK, "\n\n----- ModelFree Analysis completed ------")
report="\n-----------\n Run time: %s min \n" % (iter_time/60.)
cprint(BLUE, report)
open("MFselect.log",'w').write(report)











