#!/usr/bin/env python
import os, sys, string, pickle
import MFselect_lib_2
import mylib
from MFselect_constants import *
import xmgr
doc="""
====================== MFselect_compare.py ======================

This is a utility for extraction of data from MFselect results

Uses *.pickled files from MFselect

================================================================
"""
#------------------------------------------------------------
def remove_unassigned(data):
    'delete unassigned entries'
    to_remove=[]
    for res in data.Residue_list.get_keys():
        if data.Residue_list[res][MODEL]==UNASSIGNED: to_remove.append(res)

    print data.Residue_list.name, ": removing unassigned: ", to_remove
    for res in to_remove:
        del data.Residue_list[res]


# Pickled result names:
fname="WT.20C.ekn18.fixed_averaged_tensor.log.pickled"
fname="D121A.20C.ekn112.quick_halfNOE.full_run_optimization.log.pickled"

#-- open file ---
print "\n\nReading data from '%s'" % fname
db=mylib.open_file(fname,'r')
data=pickle.load(db)

# set proper names
data.Residue_list.set_name("WT")


#remove unassigned residues
remove_unassigned(data)

s2s_data=data.Residue_list.to_xmgr(Xcol="Key", Ycol=S2Scurr, dYcol=S2Ssimerr)

outfname=fname+".S2s"
outfile=open(outfname,'w')
for line in s2s_data:
    outfile.write("%s %s %s\n" %(line[0],line[1],line[2]))
    #print "%s %s %s" %(line[0],line[1],line[2])

outfile.close()
print "'%s' is written." %  outfname
