'a histogram'
import random


#----------- histogram -------------
# creates a histogram of x_list values in the +-interval around 0
# with a num_buckets and normalized to norm
# returns a list of bucket centers and a list of hist values
def histogram(x_list, interval, num_buckets, norm=1) :
    'makes a histogram of list values distributed in the +-interval around 0'
    

    bucket_width=2.0*interval/num_buckets
    buckets=[0]*num_buckets

    # histogram creation
    for i in x_list:
        x_to_bucket=int((interval+i)/bucket_width)
        # reject values falling out of +-interval
        try:
            buckets[x_to_bucket]=buckets[x_to_bucket]+1
        except IndexError:
            pass

    # normalization
    max=0
    for i in buckets:
        if i>max : max=i
    
    ordinate=[]
    for i in range(len(buckets)):
        buckets[i]=float(buckets[i])*norm/max
        #ordinate of a bucket center
        ordinate.append(bucket_width*(i+0.5)-interval)

    # make x,y array
    hist_out=[]
    for i in range(len(buckets)):
        hist_out.append([ordinate[i],buckets[i]])

    return hist_out

        



##
##repeats=1e6   
##print "Test of histogram"
##
##x=[]
##for i in range(repeats):
##    x.append(2*random.random()-1)
##
##out=open("teststat","w")
##hist=histogram(x,1.5,200)
##
##for i in range(len(hist[0])):
##    out.write("%s\t%s\n" %(hist[0][i],hist[1][i]))
##
##
##out.close()
##print "Done..."    
##
