#!/usr/bin/env python
#----------------------------------------
# 'init_phase.py'
#
#  v.1  Evgueni Kovriguine 8/28/02
#  Places 'p0p1.txt' file with the initial phase guess to 
# a number of directories of fids
#----------------------------------------


#-------- Input section -------------
path_to_fid_dirs='/data1/kovrigin/Raw_Data/RnaseA/temperature/7C/r2'   	  # fid data folders 
p0=0	# initial phases
p1=1
phases_fname='p0p1.txt'
#-------- End of input section --------


import os
import sys
import string 
import mylib


def place_phases (arg, dirname, names) :
  fname=dirname+'/'+phases_fname
  if os.path.isfile(fname): 
    print "File '%s' was found in '%s'!\nExiting..." % (phases_fname, dirname)
    sys.exit()
  else :
    output=open(fname,"w")
    str="%s %s" % (p0,p1)
    output.write(str)
    output.close()
 
 



os.path.walk(path_to_fid_dirs, place_phases, 'test')
os.remove(path_to_fid_dirs+'/'+phases_fname)
print "File '%s' was placed in %s data folders!" % (phases_fname, path_to_fid_dirs)
a="""
#---- check if phase files are already there ---------
if not os.path.isdir(path_to_save_files): 
  os.mkdir(path_to_save_files)
 

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
print \n----------------------------------------
*** Copying Assignments and Spectrum parameters ***
----------------------------------------




# 1. ------ files 
template_file=Load_Text_File(template_fname)
data_files=os.listdir(path_to_sp_files)


# 2. ----- find sections
spectrum_section_pos=Check_File_For_Keyword(template_fname, template_file, spectrum_section)
view_section_pos=Check_File_For_Keyword(template_fname, template_file, view_section)


# 3. ----- modify a template
print "Creating Sparky format '.save' files for:"
for sp_file in data_files :
  print "%s" % (path_to_sp_files+"/"+sp_file)

  #--- name change 
  line_num=spectrum_section_pos+spectrum_name_offset
  Check_If_Line_Is_Right(template_fname, template_file, line_num, spectrum_name_keyword) 
  template_file[line_num]=spectrum_name_keyword+" "+sp_file+"\n"

  #--- pathname change 
  line_num=spectrum_section_pos+spectrum_pathname_offset
  Check_If_Line_Is_Right(template_fname, template_file, line_num, spectrum_pathname_keyword) 
  template_file[line_num]=spectrum_pathname_keyword+" "+path_to_sp_files+"/"+sp_file+"\n"

  #---- window name change
  line_num=view_section_pos+view_name_offset
  Check_If_Line_Is_Right(template_fname, template_file, line_num, view_name_keyword) 
  template_file[line_num]=view_name_keyword+" "+sp_file+"\n"

  #--- write it out
  output=open(path_to_save_files+"/"+sp_file+".save",'w')
  output.writelines(template_file)
  output.close()
print "Done...\n"
"""