
# !!!!  Some old version with bugs!!!



#!/usr/bin/env python2
#   'ProcessAllNoe.py'
#
#   v.1  by Evgueni      09/05/2002
#
#   Processing of NOE relaxation data by a number of protocols
#
#   Needs the following macros:
#   f.com, nmrproc2.com,
#   your different protocols: nmrproc1.Px.com
#
#   Uses 'ProcessAllNoe.ini' text file located in the data
#   directory to set temperature, xCAR and phases
#
#   For phase shifting w/o processing use option: -ps
#--------------------------------------------------------------

import os
import sys
import string
import shutil

import mylib
import keywordfile

#-- !!! Treats all subdirectories as containing fids!
    
path_to_fids="/data1/kovrigin/Raw_Data/RnaseA/temperature/37C/noe/"
ini_filename="ProcessAllNoe.ini"

var2pipe_batch_macro="f.com"

protocols_to_run=[ "nmrproc1.P1.com",
                   "nmrproc1.P2.com",
                 ] # keep end comma for the case of 1 protocol!
second_part_macro="nmrproc2.com"

#-----  make a directory list --------
fids_path_slash=mylib.add_slash(path_to_fids)
dirlist=mylib.list_dirs_only(path_to_fids)
# ---- get processing parameteres -----
params=keywordfile.Keyword_File(path_to_fids,ini_filename)

#--- check mode of work requested
Yes=1
No=0
DoJustPhase=No
if '-ps' in sys.argv : DoJustPhase=Yes

if DoJustPhase==No :
    #---- check presence of two noe parts
    if len(dirlist)!=2 :
        raise UserWarning, ("\n\nError!\nFor NOE processing we need TWO fids (two parts) \
    while I see %s subdirectories in %s!" % (len(dirlist), path_to_fids))

    #---copy files to working processing directory ------------
    shutil.copyfile(fids_path_slash+dirlist[0]+'/'+"fid", os.getcwd()+'/'+"fid1")
    shutil.copyfile(fids_path_slash+dirlist[1]+'/'+"fid", os.getcwd()+'/'+"fid2")

    #--- run f.com with a correct -xCAR --------------
    os.system(var2pipe_batch_macro+" %s noe.fid no_noe.fid" % params.getval("(xCar>"))


for x in range(len(protocols_to_run)):
    num=x+1
    dirname='Protocol_%d' % num
    noe_name=dirname+"/noe.%s" % params.getval("<temperature_label>")
    NOnoe_name=dirname+"/no_noe.%s" % params.getval("<temperature_label>")
    
    if DoJustPhase==No :
        #--- create a directory
        if not os.path.isdir(dirname): os.mkdir(dirname)
     
        #--- process noe

        print "\nProcessing ",noe_name
        os.system(protocols_to_run[x] + " noe.fid  %s.zero_phases" % noe_name)
        print "\nProcessing ",NOnoe_name
        os.system(protocols_to_run[x] + " no_noe.fid  %s.zero_phases" % NOnoe_name)
        
    print "\nShifting phase of ", noe_name
    os.system(second_part_macro +   " %s %s %s.zero_phases %s.ft2 %s.sp"
          % (params.getval("<p0>"), params.getval("<p1>"),noe_name,noe_name,noe_name)
             )
    print "\nShifting phase of ", NOnoe_name
    os.system(second_part_macro +   " %s %s %s.zero_phases %s.ft2 %s.sp"
          % (params.getval("<p0>"), params.getval("<p1>"),NOnoe_name,NOnoe_name,NOnoe_name)
             )
print "\a\a\a\nDone..."
