#!/usr/bin/env python
# Here I will map dW values onto the structure. 
# NOTE: I assume that the residue list is
#  ALREADY cleaned up from overlaps and low intesity peak.

#======= USER INPUT ========

#-- no PDB extension here !
pdbname='5P21'

###-- data from 500 MHz
dataset_name='EKN32.Ras_GNP_166.RT.600'

#-- lt-list with full current assignment
current_assignment_name='../current_assignment.list'

###-- plain format residue list used for global fitting
Kex_residue_list_name="../RelaxationDispersionFitting.Alltimescale.es_list.txt.full_parsed/reslist.txt"


#---- file name for dW data 
dW_fname='dW.txt'


 #-- integer numbers for overlapped residues


Itos_not_found=[ 10, 11, 12, 13,  31,32,33,34,35,36,37,38,39, 57,58,59,60,61,62,63,64, 71]

dataname_nonempty_header_lines=1
#======= END OF USER INPUT ===========





import os,sys, string
import residues, mylib 
from pymol import cmd
import PymolLib 

reload(residues)
reload(PymolLib)
reload(mylib)


#--- clean up workspace
cmd.delete("all")
cmd.remove('all')





cmd.load(pdbname + '.pdb')
cmd.hide('all')
cmd.set('bg_rgb','[1,1,1]')


#-- load experimental values to color onto the structure
dW_data=PymolLib.text2list(dW_fname)

print dW_data



#-- get rid of water
cmd.do("""
select water, resn HOH
remove water""")


#--- show the structure
PymolLib.precise_tubes(0.3)
cmd.do('show cartoon')
#cmd.do('show tube')
cmd.color('white')
cmd.show('sticks','resi 167')   #-- GNP
cmd.color('blue','resi 167')
cmd.show('spheres','resi 168')  #-- Mg
cmd.color('sand','resi 168')




#------- color broadened switch regions
PymolLib.color_residue_list('black',Itos_not_found,'Itos_not_found')


#-- color protein structure by value of dW
#[clrschm, thrshld] = ['whtgreen',300]
#PymolLib.Color_Structure_by_Parameter(dW_data,clrschm,thrshld)
#[clrschm, thrshld] = ['whtgreen',150]
#PymolLib.Color_Structure_by_Parameter(dW_data,clrschm,thrshld)
[minVal, maxVal]= [180, 1e5]
color='red'
PymolLib.Color_Group_by_Parameter(dW_data, 1, minVal, maxVal, color, 'largedW')

[minVal, maxVal]= [60, 180]
color='pink'
PymolLib.Color_Group_by_Parameter(dW_data, 1, minVal, maxVal, color, 'mediumdW')

[minVal, maxVal]= [0, 60]
color='cyan'
PymolLib.Color_Group_by_Parameter(dW_data, 1, minVal, maxVal, color, 'smalldW')


cmd.set('sphere_scale',0.7)
cmd.select('largedW_nitrogens','largedW and name N')
cmd.show('spheres','largedW_nitrogens')
cmd.select('mediumdW_nitrogens','mediumdW and name N')
cmd.show('spheres','mediumdW_nitrogens')
#cmd.select('smalldW_nitrogens','smalldW and name N')
#cmd.show('spheres','smalldW_nitrogens')



cmd.do("""
set_view (\
    -0.334425867,    0.152653679,    0.929958105,\
     0.506072760,   -0.803332567,    0.313846916,\
     0.794995725,    0.575597882,    0.191415161,\
    -0.000224140,    0.000655260, -121.440429688,\
     4.996083260,   25.958337784,   10.942264557,\
    87.125160217,  155.721862793,    0.000000000 )



""")
  
cmd.do('deselect')

#---- save the data
cmd.do('png %s' % dataset_name+'.Kex.png')








