#!/usr/bin/env python2

doc="""-- A Pymol-based script to color the WT structure with Rex ---

"""

#---- Format of input data here is  NNN Value Error !!!
projectname="Rex_on_WT"
dataname="WT.deltaR2.Pat.txt.txt"

#projectname="DeltaRex_on_WT"
#dataname="deltaR2.WT_D121A.txt"

pdbname="7rsa.hoh.h.edited.pdb"


VALUE=0
ERROR=1
MIN_REX=3




import os,sys, string
import residues, mylib
from pymol import cmd

#--- background color ---
cmd.set("bg_rgb","[1,1,1]")
cmd.delete("all")
cmd.load(pdbname)



cmd.set_view("\
    -0.704467118,   -0.709596992,   -0.013390340,\
    -0.654202223,    0.656559527,   -0.375421315,\
     0.275192618,   -0.255715221,   -0.926751912,\
     0.000000000,    0.000000000, -154.260665894,\
    -0.295986176,    0.048400879,    0.039141655,\
  -959.394226074, 1267.915405273,    0.000000000")


cmd.hide("all")
#cmd.show("ribbon")
cmd.show("cartoon")
cmd.color("gray")
cmd.set("sphere_scale","1","all")

data=residues.Word_Dict(dataname)
print "Coloring: ",
Rex_selection="resi "
for res in data.sorted_keys():
    #--- Is this a statistically significant value?
    if float(data[res][VALUE])>2*float(data[res][ERROR]):
        #-- Does it have large Rex?
        if float(data[res][VALUE])>MIN_REX:
            Rex_selection+=res+"+"
            print " ",res,
print
Rex_selection=Rex_selection[:-1] #-- remove last +

#--- 
cmd.select("Rex_selection",Rex_selection)
cmd.show("spheres","Rex_selection")
#cmd.color("red","Rex_selection")
cmd.color("green","Rex_selection")

#--- remove water ----
cmd.select("water","resn hoh")
cmd.remove("water")



cmd.show("mesh")
#cmd.select("all")
cmd.select("dummy","none")

#--- printing out ---
cmd.set("antialias","1")
#cmd.ray(1024,768,renderer=0)
cmd.png(projectname+".png")


cmd.set_view("\
    -0.685385942,   -0.402095169,    0.607079029,\
    -0.704227865,    0.154010892,   -0.693062484,\
     0.185182005,   -0.902545631,   -0.388727933,\
     0.000000000,    0.000000000, -154.260665894,\
    -1.725999951,   -3.115000010,   -2.115999937,\
  -959.394165039, 1267.915527344,    0.000000000 ")

cmd.png(projectname+".90y"+".png")

cmd.set_view("\
     0.128333971,   -0.849274755,    0.512096345,\
    -0.765901983,    0.243158638,    0.595195413,\
    -0.630010605,   -0.468603730,   -0.619263351,\
     0.000000000,    0.000000000, -154.260665894,\
    -1.725999951,   -3.115000010,   -2.115999937,\
  -959.394165039, 1267.915527344,    0.000000000 ")
cmd.png(projectname+".along_axis"+".png")
