doc="""
Map whatever onto the structure

"""
import os



#----- Put this function in a file header 
def text2list (fname) :
    """converts text file containting 'int float' pairs into a list [int,float]"""
    if not os.path.isfile(fname): 
        print "\n\n\nError!\nCannot open '%s' to read!!!\n\n\a\a\a" % fname
	  sys.exit()
    input=open(fname,'r')	
    L=input.readlines()
    V=[]
    for line in L:
        words=line.split()
        if len(words):
                    values=[int(words[0]),float(words[1])];
                    V.append(values)
    input.close()
    return V







#---- START OF USER INPUT -----

#-- enter here the file name for data input and for png file output
data_fname='test.txt'
png_fname='test.png'


#-------------  END OF USER INPUT   ------


#--- prepare view of the structure ---
cmd.delete("all")
cmd.load("4RSD.pdb")

cmd.h_add() #-- add hydrogens
cmd.hide('all')

#-- remove water ----
cmd.select('water','resn dod')
cmd.remove('water')

cmd.color('gray')
cmd.cartoon('tube','all')
cmd.show('cartoon')
cmd.show('mesh','all')


#--- read the data file
data=text2list(data_fname)

#--- Jim, here you put the commands to map the floating value to the color

for line in data:
    residue_number=line[0] #-- this is residue number
    value=line[1]  #-- this is your floating value
    #-- confirm read-in
    print 'Residue= %d : Value= %f -----'  % (residue_number, value)

    #--- here you do your mapping
    
    
    cmd.show('spheres','resi %d' % residue_number)
#    cmd.color(color, 'resi %d' % residue_number)




#--- set an orientation---
cmd.do("""

set_view (\
    -0.605316997,   -0.048769191,   -0.794468999,\
     0.216994584,   -0.970414340,   -0.105763234,\
    -0.765812993,   -0.236420989,    0.598001122,\
     0.000000000,   -0.000000000, -121.097473145,\
    16.649000168,   17.090000153,   33.247001648,\
  -1153.253784180, 1395.448730469,    0.000000000 )


""")



#--- remove selection markers ---
cmd.select("dummy","none")

#---- printing (Good and relatively fast) ----
cmd.set("antialias","1")
#cmd.ray(1024,768)  #-- very slow on mesh --
cmd.png(png_fname)
      
