#!/usr/bin/env python


#======= USER INPUT ========

#-- no PDB extension here !
pdbname='5P21'

###-- data from 500 MHz
dataset_name='EKN32.Ras_GNP_166.RT.600'

#-- lt-list with full current assignment
current_assignment_name='../current_assignment.list'

###-- plain format residue list used for global fitting
Kex_residue_list_name="../RelaxationDispersionFitting.Alltimescale.es_list.txt.full_parsed/reslist.txt"





 #-- integer numbers for overlapped residues
overlaps=[ 14, 23, 137, 72, 141, 132, 91, 134, 92, 97, 135, 117, 145, 149, 153, 119, 158, 55, 4, 81, 49, 7, 43, 113, 109, 107, 104, 121, 76, 22, 94, 108];

Itos_not_found=[ 10, 11, 12, 13,  31,32,33,34,35,36,37,38,39, 57,58,59,60,61,62,63,64, 71]

dataname_nonempty_header_lines=1
#======= END OF USER INPUT ===========





import os,sys, string
import residues, mylib 
from pymol import cmd
import PymolLib 

reload(residues)
reload(PymolLib)
reload(mylib)


#--- clean up workspace
cmd.delete("all")
cmd.remove('all')





cmd.load(pdbname + '.pdb')
cmd.hide('all')
cmd.set('bg_rgb','[1,1,1]')


#--- load all current assignments (read lt-list)
currently_assigned=residues.Sparky_lt_Peaklist(current_assignment_name,mode=1,nonempty_header_lines=0)


#--- load residue list that went into global fitting (AnnnN-H list)
Kex_residues=mylib.Load_Text_File(Kex_residue_list_name)
Kex_residues=map(string.strip, Kex_residues) #-- get rid of '\n'






#--- show the structure
PymolLib.precise_tubes(0.3)
cmd.do('show cartoon')
#cmd.do('show tube')
cmd.color('grey')
cmd.show('sticks','resi 167')   #-- GNP
cmd.color('lightteal','resi 167')
cmd.show('spheres','resi 168')  #-- Mg
cmd.color('sand','resi 168')



#------- color assigned residues
PymolLib.color_Annn_residue_list('green',currently_assigned.get_keys(),'all_assigned')

#------- color broadened switch regions
PymolLib.color_residue_list('magenta',Itos_not_found,'Itos_not_found')

#------- color unusable overlaps
PymolLib.color_residue_list('grey',overlaps,'overlaps')

#------- color same Kex residues
PymolLib.color_AnnnN_H_residue_list('red',Kex_residues,'same_Kex')
#cmd.show('spheres','same_Kex')
cmd.select('Kex_nitrogens','same_Kex and name N')
cmd.show('spheres','Kex_nitrogens')



cmd.do("""
set_view (\
    -0.294627517,    0.002158956,    0.955601394,\
     0.409814984,   -0.903072059,    0.128383145,\
     0.863265336,    0.429447889,    0.265198797,\
    -0.000224140,    0.000655260, -104.749549866,\
     4.996083260,   25.958337784,   10.942264557,\
    70.434272766,  139.031005859,    0.000000000 )



""")
  
cmd.do('deselect')

#---- save the data
cmd.do('png %s' % dataset_name+'.Kex.png')








