"""
This module is used in 2D Peak Fitting to introduce user-defined
time dependence for the experimental series

- You set initial value of Time_coefficient here
and define the equation this coefficient is used in.

- y is time

- 'Time_coefficient_p%d' will make Time_coefficient_p0,1,2 etc for
corresponding peaks

- If you have duplicate timepoints: assign time values to them different
    by more than TIMEPOINT_SEPARATION variable below. This is just a formal feature
    to make Gnuplot distinguish duplicate data

"""

Time_coefficient_init=1 #--- Initial value of the time constant
Time_coefficient_zero=0 #-- Value making all time-dependent part = 1 (for fitting a single spectrum)

TIMEPOINT_SEPARATION=5e-8  #-- s, Timepoints should differ by more than this value from one another


#--- Math expression to multiply intensity with:


#------- Cosine evolution of inphase magnetization ---
Time_evolution_equation=" cos(3.14*Time_coeff_p%d * y) " 

#------- Exponential decay ---------
#Time_evolution_equation=" exp(-Time_coeff_p%d * y) " 
