#!/usr/bin/env python
#----------------------------------------
#  'RvsT_data_extract.py'
#
#   Extracting temperature series of R with errors for
#   particular residue and making a file for XMGR


#residue='C95'  # residue to look at
#residue='H119'  # residue to look at
#residue='V57'  # residue to look at
residue='A19'  # residue to look at

#---- where the datasets are
path_to_data='/data1/kovrigin/Processed_Data/special_cases/C95.H119/r2.P2'

#---- special suffix for result file
suffix='.P2'

#---- datasets names and temperatures
datasets={  'r2.7C.P2.decays.rates' : 7.25,
            'r2.20C.P2.decays.rates': 20.4,
            'r2.27C.P2.decays.rates': 27.5,
            'r2.37C.P2.decays.rates': 37.4,
          }

#----- dataset structure (line)
residue_name_position=0
value_position=1
error_position=2

#*************************************************************
print "\n\n--------------------------------"
print " Prepare R vs T dataset for the residue '%s'" % residue

import os
import sys
import string

import mylib
        
print "\nT\tvalue\terror"
outfile=open(path_to_data+"/"+residue+suffix, "w")
RvsT={}
##def compfunc(x,y):
##        if x>y return 
for fname in datasets.keys():
    fullfname=path_to_data+'/'+fname
    data_file_list=mylib.Load_Text_File(fullfname)
    residue_line=mylib.Check_File_For_Keyword(fullfname, data_file_list, residue)
    temp=string.atof(datasets[fname])
    value=string.split(data_file_list[residue_line])[value_position]
    error=string.split(data_file_list[residue_line])[error_position]
    RvsT[temp]=(value,error)
tempkeys=RvsT.keys()
tempkeys.sort()
for T in range(len(tempkeys)):
    print "%s\t%s\t%s" % (tempkeys[T], RvsT[tempkeys[T]][0], RvsT[tempkeys[T]][1])
    outfile.write("%s\t%s\t%s\n" % (tempkeys[T], RvsT[tempkeys[T]][0], RvsT[tempkeys[T]][1]))
    
outfile.close()

