'Comparing two F distributions'

import random
from math import *
from histograms import *
import xmgr

def statistics(list):
    '->mean, sigma'
    sum=0
    sumsquare=0
    N=len(list)
    for i in range(N) :
        x=list[i]
        sum=sum+x
        sumsquare=sumsquare+x*x
        if not i%20000 : print i, "numbers"
    return sum/N, sqrt((sumsquare-sum*sum/N)/(N-1))

#-------------------------------------------------------------

numpts=100000
# emulate fitting by model 1: distribution of G
m1_sigma=1
m1_x=map(lambda i: random.gauss(0,m1_sigma)**2, range(numpts))
m1_data=histogram(m1_x,5,100)
print "M1:", statistics(m1_x)

m1_xmgr=xmgr.Dataset(m1_data, "normal sigma=1")
m1_xmgr.no_sym()
m1_xmgr.solid_line()

# emulate fitting by model 2: normal distribution of differences
m2_sigma=0.3
m2_x=map(lambda i: random.gauss(0,m2_sigma)**2, range(numpts))
m2_data=histogram(m2_x,5,100)
print "M2:", statistics(m2_x)

m2_xmgr=xmgr.Dataset(m2_data, "normal sigma=%s" % m2_sigma)
m2_xmgr.no_sym()
m2_xmgr.solid_line()
m2_xmgr.red_line()

# emulate fitting by model 3: normal distribution of differences
m3_sigma=0.7
m3_x=map(lambda i: random.gauss(0,m3_sigma)**2, range(numpts))
m3_data=histogram(m3_x,5,100)
print "M3:", statistics(m3_x)

m3_xmgr=xmgr.Dataset(m3_data, "normal  sigma=%s" % m3_sigma)
m3_xmgr.no_sym()
m3_xmgr.solid_line()
m3_xmgr.blue_line()


# display actual distributions
normals=xmgr.Graph("Actual distributions")
normals.add_dataset(m1_xmgr)
normals.add_dataset(m2_xmgr)
normals.add_dataset(m3_xmgr)
normals.set_xaxis("X",-5,5)
normals.set_yaxis("Y",0,1)                


# create F-statistics
m12_x=map(lambda a,b: (a-b)/b, m1_x, m2_x)
m13_x=map(lambda a,b: (a-b)/b, m1_x, m3_x)
m12_mean,m12_sigma=statistics(m12_x)
m13_mean,m13_sigma=statistics(m13_x)


# plot them
m12_data=histogram(m12_x,5,100)
m12_xmgr=xmgr.Dataset(m12_data, "m12 (%.f,%.f)" % (m12_mean, m12_sigma))
m12_xmgr.no_sym()
m12_xmgr.dotted_line()
m12_xmgr.red_line()

m13_data=histogram(m13_x,5,100)
m13_xmgr=xmgr.Dataset(m13_data, "m13 (%.f,%.f)" % (m13_mean, m13_sigma))
m13_xmgr.no_sym()
m13_xmgr.dotted_line()
m13_xmgr.blue_line()

normals.add_dataset(m12_xmgr)
normals.add_dataset(m13_xmgr)

normals.writeout("normals.xmgr")
print "%s  simulations done..." % numpts
