#!/usr/bin/env python2
import string, mylib, glob, os, sys
doc="""

=========== Add truncated dataset to the full one ===================
add.py    by Evgenii Kovrigin

Adds 2D planes from two directories. If number of planes is different
(one dataset is truncated) - adds extra planes of full dataset to itself

NOTE! You should make sure the size of 2D planes is the same!!!

If number of increments in F1 dimension was different use 
nmrPipe -fn EXT -x1 1 -xn ... -sw 
for making them same.
============================================================================



"""



full_data_dir="full" 
truncated_data_dir="truncated"
nameprefix="test"

outdir="combined"
#--- clean up output directory
if os.path.isdir(outdir):
    os.system('rm -r ' + outdir)
os.mkdir(outdir)

full_list=map(os.path.basename,glob.glob(os.path.join(full_data_dir,"*")))


for file in full_list:
    full_file=os.path.join(full_data_dir,file)
    file_to_add=os.path.join(full_data_dir,file)
    #-- check if the corresponding file exists in the truncated dataset
    if os.path.isfile(os.path.join(truncated_data_dir,file)):
            file_to_add=os.path.join(truncated_data_dir,file)
    print "Adding '%s' to '%s'" % (full_file, file_to_add)

    os.system("addNMR -in1 %s -in2 %s -add -out %s/%s" % (full_file,file_to_add,outdir,file))

print "\n---------------------\nOutput written to '%s/' directory!\n" % outdir
