#!/usr/bin/env python
doc="""
=================== Adding separate fids together =====================

v.1 by Evgenii Kovrigin  11/20/04

This program reads in all files with the extension '.fid'
and adds them together using 'addNMR' program

Usage: add_fids.py

====================================================================
"""
import os, sys, string, glob

fid_mask="*.fid"            #--- the mask to find all fids in the directory
temporary_fid="add_fids.tmp" #--- temporary fid
final_fid="final.fid"   #--- final name ---


#-- remove final_fid from previous run ---
if os.path.isfile(final_fid): os.system("rm "+final_fid)

#-- read a list of files with specified extension ---
fids=glob.glob(fid_mask)
print "\n=================== Adding separate fids together =====================\n"

if len(fids)<2:
    print "\n\n\nERROR! Only one '.fid' file found! Need more than one for addition!!!\n\n"
    sys.exit()

#-- add first two ---
print "Adding: "
print fids[0]
print fids[1]
os.system("addNMR -in1 %s -in2 %s -out %s -add" % (fids[0], fids[1], final_fid))

#--- add all others ---
for i in range(2,len(fids),1):
    os.system("mv %s %s" % (final_fid, temporary_fid))
    os.system("addNMR -in1 %s -in2 %s -out %s -add" % (temporary_fid, fids[i],final_fid))
    print fids[i]


#--- remove temporary fid ------
if len(fids)>2: os.system("rm %s" % temporary_fid)

print "\nCombined fid '%s' written.\nDone." % final_fid
