#!/usr/bin/env python2
doc="""************** Adjust Phases *******************
Allows providing just increments for adjusting current
set of phases

    - initial phases should be placed in a file
        'phases.init' in a format:
        <Xp0> 111
        <Xp1> 222
        ...



    - run 'fid.com' and 'new_nmrproc1.com' on your fid first
    
    - run 'adjust_phases.py file.init'
    
    - x 111 222 [Return] to do phase correction of x-axis and rerun
      nmrproc2.XYZ.com

    - y,z - for two other axis, q - to exit

    - last set of phases is written to 'phases.final' file
      (if you want to continue phasing from this point -
      just supply this file as a command line argument)
"""

import sys,os, string
import mylib, keyfile

if len(sys.argv)<2:
	print doc
	sys.exit()

init_file=keyfile.Keyword_File(os.curdir,sys.argv[1])

nmrproc2_command="new_nmrproc2.XYZ.com %s %s %s %s %s %s"


Xp0=init_file.get_float("<Xp0>")
Xp1=init_file.get_float("<Xp1>")
Yp0=init_file.get_float("<Yp0>")
Yp1=init_file.get_float("<Yp1>")
Zp0=init_file.get_float("<Zp0>")
Zp1=init_file.get_float("<Zp1>")

sep_line="-"*20

print "Initial phases: \n%s\n\tp0\tp1\n%s\nX:\t%s\t%s\nY:\t%s\t%s\nZ:\t%s\t%s\n%s" % (
	sep_line,sep_line,Xp0,Xp1,Yp0,Yp1,Zp0,Zp1,sep_line)
#--- rerun phase-shifting macro ----------
# Z-phases supplied negative due to a glitch in nmrproc2.XYZ.com
os.system(nmrproc2_command % (Xp0,Xp1,Yp0,Yp1,-Zp0,-Zp1))



while 1:

	print "Enter: x, y or z for the particular axis followed by delta p0 and delta p1 values. q - exit"

	input=sys.stdin.readline().split()

	if not input: continue  # -- enter press
	
	#--- exit --------
	if "q" in input: break

	#--- check allowed commands ----
	if input[0] not in ['x','y','z']:
		print "\a\a\aErroneous command!!!!  : ", input[0]
		print
		continue

	#--- check number of arguments ----
	if len(input)!=3:
		print "\a\a\aError! Enter two numbers after the axis name: p0 and p1!\n"
		continue

	#----- command processing ----	
	if input[0]=='x':
		Xp0=Xp0+eval(input[1])
		Xp1=Xp1+eval(input[2])

	elif input[0]=='y':
		Yp0=Yp0+eval(input[1])
		Yp1=Yp1+eval(input[2])

	elif input[0]=='z':
		Zp0=Zp0+eval(input[1])
		Zp1=Zp1+eval(input[2])

	else: print "shit!"
	#--- rerun phase-shifting macro ----------
	# Z-phases supplied negative due to a glitch in nmrproc2.XYZ.com
	os.system(nmrproc2_command % (Xp0,Xp1,Yp0,Yp1,-Zp0,-Zp1))

	print "New phases: X:\t%s\t%s\tY:\t%s\t%s\tZ:\t%s\t%s" % (Xp0,Xp1,Yp0,Yp1,Zp0,Zp1)


print "Please, find your final set of phases in 'phases.final'..."

mylib.open_file("phases.final", 'w').write(
"""New phases:

<Xp0>	%s
<Xp1>	%s

<Yp0>	%s
<Yp1>	%s

<Zp0>	%s
<Zp1>	%s""" % (Xp0,Xp1,Yp0,Yp1,Zp0,Zp1))
