"""
Sparky module to detect assignments failed to center on the peak and sitting
on noise instead

"""

import residues, keyfile, mylib
import sys,os
import sparky
  

text=""" ---- Do this because default noise figure is INCORRECT:
1) Close the peak list window
2) Determine the real noise RMSD of your spectrum ('rm' - Region RMSD)
3) Insert it into the 'Estimated noise' field ('st' - 'Spectrum window')
   and click 'OK'
4) Press 'el' again"""

def run(session):
    session.command_characters("py")
    print
    print "******************* Check Low Intensities **********************"

    cur_view=session.selected_view()
    #--- check if window is open ----
    if not cur_view:
        print "\n\n!!! Error!  Need a spectrum selected !!!\n\n"
        return

    
    cur_spec=cur_view.spectrum

    print text
   
        

    print "Noise figure used now: ", cur_spec.noise
    print "Searching for peaks lower than 10x noise..."

    peak_list=cur_spec.peak_list()
     
    OL_list=[]

    N=len(peak_list)
    
    for i in range(N):
        
        peakA=peak_list[i]

        height=peakA.data_height
        height_cutoff=10*cur_spec.noise

        if height<height_cutoff:
            
             OL_list.append(peakA)

    print "%d peaks found..." % len(OL_list)

    session.show_peak_list(OL_list)
    session.command_characters("py")
   
