"""The module defining the functions to colorize the standard output.

Use it as:

import colors
from colors import *
#-- to make it portable: use color only when requested explicitly
if '-color' in sys.argv: colors.COLOR=ON


cprint(RED, 'dddd')
print "aaa = %s" % clr(RED, 'ddd')

"""

OFF,ON=0,1

COLOR=OFF


#-- color codes ---

RED=31
GREEN=32
YELLOW=33
BLUE=34
PINK=35
CYAN=36
UNDERLINE=4
BOLD=1
BLINK=5
INV=7
INV_GREY=100
INV_RED=101
INV_GREEN=102
INV_BLUE=104
INV_PINK=105
INV_CYAN=106



def clr(color, text):
    '-> colorized string'
    if COLOR==ON: return (("\033[01;%dm" % color) +text+"\033[00m")
    else: return text
    
def cprint(color, text):
    'prints colorized text'
    print clr(color, text)
    
def cprintnnl(color, text):
    'prints colorized text, inserts no new line'
    print clr(color, text),

##min=int(raw_input("min>"))
##max=int(raw_input("max>"))
##
##for a in range(min, max):
##      
##   print "Integer=%d  \033[01;%dmkeyfile.pyc\033[00m" % (a,a)

if __name__=="__main__":
        
    a="string"
    print a
    print "%s %s %s" % (clr(INV_RED,a),clr(BLINK,a),clr(INV_GREY,a))
    cprint(INV_GREEN,a)
