#!/usr/bin/env python
doc="""
================== Calculation of delta (Rex) from 2 R2 datasets =================

Usage: dRex_calc.py long_taucp_file short_taucp_file output_fname

---------------------------------
Rates should be ANNN x dx
Use 'extract_common_residue_set.v2.py' utility to make lists the same

========================================================="""

import os, sys, string 
import mylib, xmgr, residues

if len(sys.argv)<4:
    print doc
    sys.exit()

long=residues.Annn_Num(sys.argv[1])
short=residues.Annn_Num(sys.argv[2])
delta=short.make_empty_copy(sys.argv[1]+' - '+ sys.argv[2])

#--- check that the residue sets are the same ---
residues.check_keys_match(long,short)


print long
print short

for residue in long.sorted_keys():
    dR2=long[residue][0]-short[residue][0]
    err=long[residue][1]+short[residue][1]
    delta[residue]=[dR2,err]

delta.writeout(sys.argv[3])
