#!/usr/bin/env python

doc="""
****************************************************************
      Determination of potentially overlapping peaks
----------------------------------------------------------------

Needs a peak list with coordinates from low-resolution protocol
and two values: ppm distance of minimally resolved peaks in
proton (dHmin) and nitrogen (dNmin) dimensions

Usage: detect_overlap.py  -H dHmin -N dNmin  -l peaks.list  -o outfilename

*****************************************************************
"""


import residues, sys, os

if len(sys.argv)<9 or sys.argv[1]!="-H" or sys.argv[3]!="-N" or sys.argv[5]!="-l" or sys.argv[7]!="-o":
	print doc
	sys.exit()

	
dHmin=float(sys.argv[2])
dNmin=float(sys.argv[4])
fname=sys.argv[6]
outfname=sys.argv[8]



Nppm,Hppm=0,1

peak_list=residues.Word_Dict(fname,mode=0, nonempty_header_lines=1)
outI=open(outfname+".nonredundant",'w')
outII=open(outfname+".pairs",'w')

res_list=peak_list.get_keys()


 
OL_list=[]
for res1 in res_list:
    
    i=res_list.index(res1)
    
    for res2 in res_list[i+1:]:
        Ndist=abs(eval(peak_list[res1][Nppm])-eval(peak_list[res2][Nppm]))
        Hdist=abs(eval(peak_list[res1][Hppm])-eval(peak_list[res2][Hppm]))
#        print res1,Ndist, Hdist,
        if Ndist<dNmin and Hdist<dHmin:
            outII.write(res1[:-3]+"\t"+res2[:-3]+"\n")
            if res1 not in OL_list:
                OL_list.append(res1)
            if res2 not in OL_list:
                OL_list.append(res2)



#            outI.write(res1[:-3]+"\n"+res2[:-3]+"\n")            

for res in OL_list:
    outI.write(res[:-3]+"\n")
outI.close()
outII.close()

