doc="""
------------- DIFFERENCE -------------------
calculate difference between two datasets for residues found in both of them
----------------------------------------------
"""

import os,sys,string,residues,mylib,xmgr
reload(residues)



fname1="WT.20C.deltaR2.ekn98.txt"
fname2="D121A.20C.deltaR2.ekn98.txt"
outfname="deltaR2.WT_D121A"

VALUE=0
ERROR=1


full_set1=residues.Word_Dict(fname1)
full_set2=residues.Word_Dict(fname2)

set1=full_set1.get_intersection(full_set2.get_keys())
set2=full_set2.get_intersection(full_set1.get_keys())

set1.convert_values_to_float()
set2.convert_values_to_float()

baseline_residues=['3','10','53','113']
set2.vert_offset_correction(baseline_residues,VALUE)
set1.vert_offset_correction(baseline_residues,VALUE)

difference=set1.make_empty_copy("Difference: %s - %s"%(set1.get_name(),set2.get_name()))



for key in set1.get_keys():
    dValue=set1[key][VALUE]-set2[key][VALUE]
    dErr=set1[key][ERROR]+set2[key][ERROR]
    difference[key]=[dValue,dErr]

difference.writeout(fname=outfname, header="OFF",verbose=1)

#--- xmgr output ---

a=xmgr.Dataset(difference.to_xmgr("Key",VALUE,ERROR))

b=xmgr.Graph(difference.get_name())
b.add_dataset(a)
b.set_xaxis("Residue",0,130,13,10)
b.set_yaxis("Delta Rex change",-10,20,10,2)
b.writeout(outfname+".xmgr")

