#!/usr/bin/env python
# 'duplicate_errors.py'
#   Error analysis in  duplicates

import os, sys, string
from keyfile import *
from mylib import *
from histograms import *
from math import sqrt

#---------- determine sigma and mean of dH/Havg
def stat_on_dHrel(H1_list, H2_list) :
    sum=0
    sumsquare=0
    N=len(H1_list)
    for i in range(N) :
        Havg=(H1_list[i]+H2_list[i])/2
        x=(H1_list[i]-H2_list[i])/Havg
        sum=sum+x
        sumsquare=sumsquare+x*x
        mean=sum/N
        sigma=sqrt(((sumsquare-sum*sum/N)/(N-1)))
    return mean,sigma


    

#**************************************************************************
path_to_data="/data1/kovrigin/Processed_Data/noe.7C/P1.parts_separate"
inp_fname="noe.7C.P1.parts_sep.list"
duplicate1_col_name="noe.7C.1.sp/0.002"
duplicate2_col_name="noe.7C.2.sp/0.002"

# output files
hist_out_fname=os.path.join(path_to_data,inp_fname+".hist")
abs_dhh_corr_out_fname=os.path.join(path_to_data,inp_fname+".corr.absdh_vs_h")
rel_dhh_corr_out_fname=os.path.join(path_to_data,inp_fname+".corr.reldh_vs_h.no_noe")

inp_file=Keyword_File(path_to_data,inp_fname)

# find two columns
point_1st=find_column(inp_file[0], duplicate1_col_name)
point_2nd=find_column(inp_file[0], duplicate2_col_name)

#remove non-numeric header 
inp_file.remove_index(0)

#generate lists of floating point heights and differences
h1=[]   # 1st height
h2=[]   # 2nd height
dx=[]   # h1-h2
count=0
for x in inp_file:
    h1.append(float(x[point_1st]))
    h2.append(float(x[point_2nd]))
    dx.append(h1[count]-h2[count])
    count=count+1

#generate a histogram of differences
out=open(hist_out_fname,"w")
for i in filter(None,histogram(dx, 4e5,40)):
    out.write("%s\t%s\n" % (i[0],i[1]))
out.close()

#generate a correlation plot dx vs. average height
# and dx/avg vs height
abs_corr_out=open(abs_dhh_corr_out_fname,"w")
rel_corr_out=open(rel_dhh_corr_out_fname,"w")
for i in range(len(dx)):
    avg_h=(h1[i]+h2[i])/2
    abs_corr_out.write("%s\t%s\n" % (avg_h,dx[i]))
    rel_corr_out.write("%s\t%s\n" % (avg_h,dx[i]/avg_h))
abs_corr_out.close()
rel_corr_out.close()

print "\n-------------\n", inp_fname
print duplicate1_col_name
print "mean dH/H = %s\nrmds= %s\n---------\n" % stat_on_dHrel(h1,h2)


