"""Reading xmgr files created by CurveFit after fitting of EtaXY data
"""
import os,sys,string
import mylib


residue="T45"


def get_etaxy(path,residue):
    'reads XMGR file from etaxy fitting -> [value,error,number_of_points_fitted]'

    fname=os.path.join(path,residue+".xmgr")
    
    if not os.path.isfile(fname): return []   #-- file doesn't exist

    #-- read it
    file=mylib.open_file(fname,'r').readlines()

    word="points"
    (strnum,wordnum)=mylib.Find_Position(file, word)
    points=file[strnum].split()[2]


    word="Rate"
    (strnum,wordnum)=mylib.Find_Position(file, word)
    rate=file[strnum].split()[2]
    error=file[strnum].split()[5]


    return {"rate":rate, "error":error, "points":points}







if __name__=="__main__":
    
    print get_etaxy(path,"A125")
