#!/usr/bin/env python
doc="""
================== Plot relaxation data =================
extract_common_residue_set.py d1 d2 ...

outputs d1.extr d2.extr ... containing data for the common set of residues

========================================================="""

import os, sys, string,  glob 
import mylib, xmgr, residues


NON_EMPTY_HEADER_LINES=0

if len(sys.argv) < 3:
    print doc
    sys.exit()


#-- source data
d=[]
for fname in sys.argv[1:]:
    d.append(residues.Word_Dict(fname,mode=1,nonempty_header_lines=NON_EMPTY_HEADER_LINES))

#-- find common set of residues
intersection=d[0].get_keys()
for dataset in d[1:]:
    intersection=dataset.get_intersection(intersection).get_keys()


print '*'*60
print "Intersection of %s datasets is:\n" % (len(sys.argv)-1), intersection

#--- form new datasets
d_extr=[]
for dataset in d:
    d_extr.append(dataset.get_intersection(intersection))

#--- export
for dataset in d_extr:
    dataset.writeout(dataset.get_name()+'.extr', header="off", verbose="on", mode='w')

