#!/usr/bin/env python
import os,sys,string
import MFselect_lib_2
import residues
import mylib
import keyfile
import copy
from MFselect_constants import *

doc= """
**************************************************
extract_nonexch.py v.2
EKN 14.4

The program takes a list of residues "to extract"
and three datasets.

The lists may differ. The program returns in effect
the set of residues common to 'residue_list_to_extract"
and to the datasets


Usage:   extract_nonexch.py -l residues_list -d dataset1 dataset2 dataset3

    Exported files have prefix 'nonexch.'

**************************************************
"""

if len(sys.argv)<7 or ('-l'!=sys.argv[1]) or ('-d'!=sys.argv[3]):
    print doc
    sys.exit()

res_fname=sys.argv[2]
d1_fname=sys.argv[4]
d2_fname=sys.argv[5]
d3_fname=sys.argv[6]

res_list=residues.Annn_Text(res_fname,1)
d1_list=residues.Annn_Text(d1_fname,1)
d2_list=residues.Annn_Text(d2_fname,1)
d3_list=residues.Annn_Text(d3_fname,1)

d1=d1_list.get_keys()[:]
for res in d1:
    print res,
    if res not in res_list:
        del d1_list[res]
        print " skipped"
    else: print " taken"

d2=d2_list.get_keys()[:]
for res in d2:
    if res not in res_list:
        del d2_list[res]

d3=d3_list.get_keys()[:]
for res in d3:
    if res not in res_list:
        del d3_list[res]


d1_list.writeout("nonexch."+d1_fname, header="OFF",verbose=1)
d2_list.writeout("nonexch."+d2_fname, header="OFF",verbose=1)
d3_list.writeout("nonexch."+d3_fname, header="OFF",verbose=1)
