#!/usr/bin/env python2
doc="""
-----------------------
'fold_assignments.py'
by Evgueni Kovriguine      07/03/03

1. start with wide spectral width .save file
2. take parameters of new spectral width
3. create a file where all assignments either
    (1) moved to new places
    (2) properly 'aliased'

accuracy with relation to what Sparky shows - about +-0.1 ppm N


Usage:
        fold_assignments.py  sw.ini 
        
          sw.ini contains parameters of new spectral width

--------------------------
"""


import os,sys, string
import mylib, keyfile


if len(sys.argv) !=2:
    print doc
    sys.exit()


ini_fname=sys.argv[1]

ini_pars=keyfile.Ini_File(ini_fname)
source_save_fname=ini_pars.get_string("<full_sw_save_file>")
new_save_fname="RedSw."+source_save_fname

#-- calculate new ppm limits

Obs=ini_pars.get_float("<Obs>")         # MHz or Hz/ppm
Car=ini_pars.get_float("<Car>")         # ppm

fold_w=ini_pars.get_integer("<fold_w>") # 1,2...
swHz=ini_pars.get_float("<sw>")

delta=swHz/(Obs*2)
min_ppm=Car-delta
max_ppm=Car+delta
sw_ppm=2*delta

print "\n\n\nFolding the spectrum '%s'" % source_save_fname
print "new ppm limits:", min_ppm, max_ppm




#-- go through the Sparky file and replace 
source=mylib.Load_Text_File(source_save_fname)
end_line=mylib.Find_String_Num(source, "ornament>")

line_num=0
while 1 :
    words=source[line_num].rstrip().split(' ')
    #print words
    #-- when to stop 
    if words==['<end','ornament>']: break

    #-- waiting for new peak description to begin
    if words!=['type','peak']:
        line_num+=1
        continue
    else:
        #- ! definition of a peak began !

        while words[0]!='label':
            #--- look for position            
            if words[0]=='pos':
                #-- position found
                if len(words)< fold_w+1:
                    raise UserWarning, "\n\n\nError!!! <fold_w> parameter is set to %d \
        while number of dimensions is just %d!\n\n\n" %(fold_w,len(words)-1)
                
                curr_ppm=float(words[fold_w])

                #-- analyze >
                folded='no'
                if curr_ppm>max_ppm:
                    #-- fold it!
                    times_folded=int((curr_ppm-min_ppm)/sw_ppm)
                    new_ppm=curr_ppm-sw_ppm*times_folded
                    words[fold_w]=str(new_ppm)
                    folded='yes'

                #-- analyze <
                if curr_ppm<min_ppm:
                    #-- fold it!
                    times_folded=int((max_ppm-curr_ppm)/sw_ppm)
                    new_ppm=curr_ppm+sw_ppm*times_folded
                    words[fold_w]=str(new_ppm)
                    folded='yes'
                    
                #-- load it back
                if folded=='yes':
                    source[line_num]=string.join(words)+'\n'
                    
            line_num+=1
            words=source[line_num].rstrip().split(' ')

        else:
            #-- yes, label found
            peak=words[1]
            if folded=='yes':
                print "Peak '%s' aliased from %.3f ppm to %.3f (%dx folded)" % (
                    peak,curr_ppm, new_ppm, times_folded)
                #-- stop searching peak parameters
            line_num+=1

        
#--- write it out
output=open(new_save_fname,'w')
output.writelines(source)
output.close()
    
