#!/usr/bin/env python
import string,  glob, os, sys
doc="""===== Generate an HTML insert for your notebook for a current residue ====
by Evgenii Kovrgin,
Medical College of Wisconsin
2/18/09

Usage:
1. Generate an HTML list with one row with all pictures
   from appropriate locations so replacement of the residue name
   would correctly access pictures for a new residue.
   
2. Copy HTML code for this row in this program below

3. Replace your specific residue name you had with the generic word RESIDUE

4. Run:   generate_HTML_row.py  residue list  
    where
            residue list contains a column of residue names in a single-letter
            amino acid code  like "T2". No header or footer lines!

        
5. Copy-paste contents of "HTML_row_output.txt" into your HTML notebook

"""

#================ USER INPUT =============================

template_word='RESIDUE'


HTML_template="""
  <li>    <h2>    <strong>RESIDUE</strong></h2>
    <img src="data/rcCPMG/two-protocol-analysis/resolution_images/RESIDUE.png" alt="" width="606" height="263" />
    <br />
    <img src="data/rcCPMG/added.LowRes/sp/Sparky/eS.LR.500.20C.120ppm.txt.data/R2vsHz/RESIDUE_RelaxationDispersion.png" alt="" width="400" height="300" />
    <img src="data/rcCPMG/two-protocol-analysis/comparison/PNG/RESIDUE.png" alt="" width="400" height="300" /><hr /></li>
"""
output_fname="HTML_row_output.txt"


#================= END OF USER INPUT =====================

if len(sys.argv)<2:
    print doc
    sys.exit()

    
reslist_fname=sys.argv[1]

finp=open(reslist_fname,'r')
foutp=open(output_fname,'w')

residues=finp.readlines()


#-- make an new HTML row
print "Making HTML row for: "
counter=1
for line in residues:
  #-- extract residue name
  resname=string.strip(line)
  if not resname : continue  #- skip empty lines
  
  print "%d:   %s" % (counter, resname)
  
  
  #-- replace template word with a residue name
  new_row= string.join(HTML_template.split(template_word),resname)
  
  foutp.write(new_row)
  counter+=1
  
  
  
finp.close()
foutp.close()

print '\n"%s" written.\n' % output_fname
  
  
  
  
  
  
  
  
  
  
  
  































