#!/usr/bin/env python
import string, mylib, glob, os, sys
doc="""====================== Help Concatentate Intensity Data ===================
by Evgenii Kovrigin   8/5/08
Medical College of Wisconsin
v.1

This program generates a piece of code needed to set up concatenate_intensity_data.py.
It reads a residue list and produces a 'resname_dict={}' code that you cut-and-paste into 
concatenate_intensity_data.py.

I use this program to concatenate two rcCPMG datasets each with three points in the interleaved
series for frequencies to make 6-point datasets for each CPMG frequency. (See EKN42)

"""

#===== USER INPUT SECTION ==========
#-- list of residues to place in resname_dict{}
reslist_name='/Users/kovrigin/Documents/Workspace/Data/Data.XIII/EKN42.rcCPMG.RasGNP166.RT.500/data/rcCPMG.118ppm/added_odd_half/sp/Sparky/eS.500.22C.118ppm.odd_half.txt.parsed.v1/reslist.txt'
#-- list of keys you need in paths{}
keys=['odd','even']


#===== END OF USER INPUT SECTION ==========

residues=mylib.Load_Text_File_NonEmpty_Lines(reslist_name)
print 'Reading %s' % reslist_name

# Generate a code for concatenate_intensity_data.py
print "---- cut after this line -----"
outtext="resname_dict={\n"
for line in residues:
    resname=line.strip()
    outstring="'%s' : [ " % resname
    for key in keys:
       outstring+="'%s'," % key
    outstring=outstring[:-1] + " ],\n"
    outtext+=outstring
outtext=outtext[:-2]+"\n}"

print outtext

print "---- cut before this line -----"
    




