---------- OLD FILE - use 'keyfile' instead !!! --------



' Class definitions to handle text data idexed by keywords'
import sys
import os
import string
import mylib

class Keyword_File:
    """text file handling (general puprose)
    - opens files and do checks
    - separates files into lines and into words
    - keeps a text file as a list of lists of words from each line
    """
    filename=None       # source data file
    iterator_counter=0  
    

#---------- constructor -----------------------------
    def __init__(self, path_to_data, file_to_load,
                 number_fileheader_strings=0)   :
        'loads a file as a list of lists'
        self.text=[]             # list of list of words from each string        
        # check path
        path_to_data=string.rstrip(path_to_data)
        if not os.path.isdir(path_to_data) :
             raise IOError, "\n\nDirectory '%s' doesn't exist!" % path_to_data
        
        # check a file
        self.filename=os.path.join(path_to_data,file_to_load)
        if not os.path.isfile(self.filename) :
            raise IOError, "\n\nFile %s doesn't exist!" % self.filename
        inputstream=open(self.filename, 'r')
        if not inputstream :
            raise IOError, "\n\nCannot read file '%s'!" % self.filename

        # read all, make a list of lists
        raw_strings=inputstream.readlines()

        # strip off empty lines at the end
        while( len(string.split(raw_strings[-1]))<1):
            del(raw_strings[-1])
            # check presence of the file body left
            if len(raw_strings) < 1 :
                raise UserWarning, "\n\nThe data file '%s' is empty!" % self.filename

        # fill in an array
        for str in raw_strings:
            list=string.split(str)
            self.text.append(list)
#--------------------------------------------------------

#--------- print and 'x' -----
    def __repr__(self):
        fulltext=["File:\n"+self.filename+"\n-----------------\n"]
        for key in self.text:
            fulltext.append(string.join(key,'\t')+"\n")
        return string.join(fulltext)

#--- length, truth------------
    def __len__(self):
        return len(self.text)


#-------- 'human' indexing [1,2,3,...] -----
    def __getitem__(self, line_number):
        'list by a number'
        return self.text[line_number-1]


#------------- getting a line by keyword in the first column -----------
    def getall(self, keyword):
        'find a line by keyword, returns the found line or raises exception'

        for line in self.text:
            if line==[] : continue  # skip empty line in the body
            if keyword==line[0]: break
        else:
            raise UserWarning, (
            "\n\nError!\nKeyword '%s' is not found in '%s'!" % (keyword, self.filename))
        return line


#------------- getting the first word after a keyword (second column word)-----------
    def getval(self, keyword):
        'find a line by keyword, returns the found line or raises exception'
        
        return self.getall(keyword)[1]


#---- iterator: return a line------------------------------
    def __iter__(self):
        return self
    
    def next(self):
        current=self.iterator_counter

        if not current<len(self):
            self.iterator_counter=0
            raise StopIteration
        
        self.iterator_counter=self.iterator_counter+1
        return self[current]


#--------------------------------------------------------------------------    

    def remove(self, index):  # human index 1,2,3 ...
        x=self.text[index-1]
        self.text.remove(x)
        
        
        

##    #------------ Assigning new data to residues -----------------------
##    def __setitem__(self, line_number, new_value_list):
##        'assign a list to a line'
##        # convert to string presentation first
##        temp=[]
##        for word in new_value_list: temp.append(str(word))
##        self.text[line_number]=  temp      

##
##x=Keyword_File('/data1/kovrigin/Processed_Data/Processing/PythonLib/ ',
##            'r1.37C.P1.decays.rates')
##
##print x
##
##for item in x :
##    print "===", item[0]
