#!/usr/bin/env python2
doc="""
*********************** Group selection *********************************
Macro-generator for easier selection of arbitrary groups in molmol

Usage: select_group n1 n2 n3 n4 ... as many as you like
it generates a molmol command (to glue and paste)
to select some (specified in the text below) atoms of these residues.

************************************************************************
"""

AtomSelection=["N","CA"] #-- select these in each residue

import sys, string

if len(sys.argv)<3:
    print doc
    sys.exit()

residues=sys.argv[1:]

#-- generate residue selection line
res_string=""
for residue in residues:
    res_string+=" res.num="+residue+" or"
res_string=res_string[:-2]
#print res_string

#-- generate atom selection line
atom_string=""
for atom in AtomSelection:
    atom_string+=' name="'+atom+'" or'
atom_string=atom_string[:-2]
#print atom_string

print "Molmol command for selection of %s residues:\n----------------------------------\n\
SelectAtom '(%s) & (%s)'\n----------------------------------" % (residues,res_string,atom_string)
