#----------------------------------------------------------------------------
def select_peaks_2D(spectrum, Annn_list_to_select, set_selected=1, verbose=1):
    'selecting peaks in 2D -> set peaks to "selected" if 1 and returns list of selected peak objects'
    
    if spectrum.dimension!=2:
        raise UserWarning, "Cannot select peaks in %dD!!!" % spectrum.dimension
    
    
    #-- first: unselect all ---
    for peak in spectrum.peak_list():
        peak.selected=0

    #-- select requested ones --
    selected_list=[]
    if verbose: print "Select %d peaks: " % len(Annn_list_to_select),
    for peak in spectrum.peak_list():
        res=peak.assignment[:-3]
        if res in Annn_list_to_select:
            if set_selected: peak.selected=1
            selected_list.append(peak)
            if verbose: print res
            
    return selected_list
#--------------------------------------------------------------------------------        
        

def get_resname(peak):
    'AxxxH-N -> Axxx'
    return peak.assignment[:-3]
#--------------------------------------------------------------------------------        
