#!/usr/bin/env python
#-- carrier offset calculations

#/*--- constants: GammaX/GammaH ---*/
k_NH = 0.101329118
k_CH = 0.251449530

#!/usr/bin/env python

#-- spectrometer frequency on proton channel, MHz
BF1=599.87

#-- proton offset, Hz
O1=2820.0

#-- proton carrier frequency, ppm
H_car=4.80


#-- X-channel spectrometer frequency
BFX=60.78429

#-- X-nucleus carrier frequency, ppm
#X_car=112.9  #-- nitrogen of NAG
X_car=113.  #-- nitrogen of NAG

#-- X-nucleus constant
k_XH=k_NH #-- nitrogen



#-- calculate 0ppm frequency for proton

nuH= (BF1*1e6+O1)/(1+H_car*1e-6)


#-- calculate 0ppm frequency for X-nucleus
nuX = nuH*k_XH

#-- calculate frequency at required ppm on X-nucleus
SFX= nuX*(1+X_car*1e-6)


#-- required offset value
OX= SFX-BFX*1e6

print" \n---- X-nucleus offset calculations ---"
print "Evgenii Kovrigin, 1/26/08\n"
print "Proton carrier is set at %.3f ppm " % H_car
print "X_nucleus carrier to be at %.3f ppm" % X_car
print "Proton offset, O1 used: %.3f Hz" % O1
print "Base proton spectrometer frequency, BF1: %.7f Hz" % (BF1)
print "Base X-nucleus frequency, BFX:  %.7f Hz" % (BFX)
print "-"*20
print "Required OX: %.3f Hz" % OX



