#!/usr/bin/env python2
doc="""
The script to queue execution of programs in different directories
"""


email_notification='off'  #--- if you are going to check e-mail
email_server='mail.yale.edu'
email_account='evgueni.kovriguine@yale.edu'
email_name="Queuer"
log_fname="queuer.log"


#--------------- directories where your excecutables are
#       and the executable names (!!! Cannot run background processes
#       because it cannot WAIT for such process to finish !!!)
#---------------------------------------------------------------
queue_list=[

("/data1/kovrigin/Processing/PythonLib", "pwd;ls"),

("/data1/kovrigin/Processing/PythonLib/Old_unused", "pwd;ls"),

("/data1/kovrigin/Processing/PythonLib/Utilities", "pwd;ls"),


]




#----------------------- END OF USER INPUT -----------------------
import os, sys, thread, time
import mylib
from smtplib import *


def email(my_name,subject, text, email_server, email_account):
    'sends an email with the text in the subject line'
    message="Subject:%s\n\n%s" %(subject,text)
    if email_notification in ('on', 'ON'):
        try:
            server=SMTP(email_server)
            failed=server.sendmail("%s@python" % my_name, email_account, message)
            server.quit()
        except:
            mylib.open_file("failed_email.log",'a').write("Exceptions raised on sending a message to '%s'\nMessage text: %s\n"
                                                    % (email_server, text))
            return
        
        if failed:
            mylib.open_file("failed_email.log",'a').write("Address failed on sending a message to '%s'\nMessage text: %s\n"
                                        % (email_server, text))

def notify_me(my_name, subject, text):
    'spawn an email sending thread'
    thread.start_new(email,(my_name,subject, text,email_server,email_account))
#-





    

cur_dir=os.getcwd()
num=1
for dir,command in queue_list:

    
    #---- starting message ----
    
    text="\n"+'='*50+"\nProcess [%d]\nStarting %s : %s\n" %(num, dir,command)
    open(log_fname,'a').write(text)
    notify_me(email_name,"started - %d" % num,text)
    print text

    #--- run it ! ----
    start=time.time()
    os.chdir(dir)
    exit_status=os.system(command)
    stop=time.time()
    os.chdir(cur_dir)
    report="%s execution time was %s sec" % (sys.argv[1], stop-start)

    #---- ending message ----
    text="[%d] finished (exit status: %s)\n%s" % (num, exit_status,report)
    open(log_fname,'a').write(text)
    notify_me(email_name,"finished - %d" % num, text)
    print text

    num+=1
    
text="Queue finished"
open(log_fname,'a').write(text)
notify_me(email_name,"queue finished", str(queue_list))
print text

