#!/usr/bin/env python2

#--- These are suffixes to get rid of !!! ------
known_suffixes=['CH','NH','C-H','N-H']

doc="""========== Remove Assignment Suffix =============
by Evgenii Kovrigin  04/06/05

(for preparation of the rates data to 'rsd_CH' input)

This program reads all the files in the directory and
converts assignment names in following manner:

H119C-H =>  H119

Currently known suffixes: %s

Usage:  remove_assignment_suffix.py dirname



""" % known_suffixes




import os, sys, string, glob
import residues

if len(sys.argv)<2:
    print doc
    sys.exit()

dirname=sys.argv[1]

data=glob.glob(os.path.join(dirname,'*'))

print "\nRemoving suffixes from residue names:\n"

for fname in data:
    #--- test each dataset ---
    dataset=residues.Word_Dict(fname)
    original_keylist=dataset.get_keys()
    #--- test each residue -----
    for key in original_keylist:
        #--- test each suffix -----
        for count in range(len(known_suffixes)):
            if key.find(known_suffixes[count])!=-1:
                #--- yes! found ---
                new_key=key[:-len(known_suffixes[count])]
                #--- replace a key now
                value=dataset[key]
                del dataset[key]
                dataset.add(new_key,value)
                
    dataset.name+=".txt"
    print dataset
    dataset.writeout(fname+".txt",header="OFF")
                







