#!/usr/bin/env python
doc="""
================== Remove residues =================
Takes an lt-list 'source_list' of residues from Sparky and removes
from this list residues found in 'unwanted_list'. Both lists are Sparky 'lt'
lists. The result is 
recorded in 'cleaned_up_list' and is importable into Sparky with 'ey'.

Usage: 
remove_residues.py  source_list unwanted_list cleaned_up_list  



========================================================="""

import os, sys, string,  glob 
import mylib,  residues


NON_EMPTY_HEADER_LINES=0

if len(sys.argv) < 4:
    print doc
    sys.exit()

#-- cleaned up file
cleaned_up_fname=sys.argv[3]

#-- source data
source_fname=sys.argv[1]
print "Reading source data: '%s'" % source_fname
source=residues.Sparky_lt_Peaklist(source_fname,mode=0,nonempty_header_lines=0)

#-- unwanted data
unwanted_fname=sys.argv[2]
print "Reading unwanted data: '%s'" % unwanted_fname
#unwanted=residues.Annn_Text(unwanted_fname)
unwanted=residues.Sparky_lt_Peaklist(unwanted_fname,mode=0,nonempty_header_lines=0)


#-- remove unwanted
for resname in unwanted.get_keys():
  if resname in  source.get_keys():
    source.del_keys( [resname ])
    print "Deleting ", resname
  else:
    print "Not found: ", resname

#--- save cleaned up list
source.writeout(cleaned_up_fname, header="off", verbose="on", mode='w')

