#!/usr/bin/env python2

doc="""--------- run_gnuplot -----------

This function is written to run gnuplot from Python script.

'gnuplot_command' should contain all the commands you would normally
give to gnuplot. Before inserting it into 'gnuplot_command' - test it
in gnuplot!!! I don't catch gnuplot error messages

Note: it doesn't contain 'exit' command !!!

You can leave 'variable_string' empty and just generate a graph.


"""


import os,sys

import popen2,string

import mylib



temp_fname="gnuplot_output"
def gnuplot(gnuplot_command,variables_string=""):
    'keywords string give UNIQUE names of variables to extract from output'

    
    gnuplot=popen2.Popen4("/usr/local/bin/gnuplot\n",0)
    gnuplot.tochild.write(gnuplot_command)


    #-- extract variables names ---
    keywords=variables_string.split()

    #-- Ask gnuplot to output them --
    for keyword in keywords:
        gnuplot.tochild.write('print "<<<%s>>>\t", %s\n' % (keyword,keyword))
        
    #-- Finish gnuplot session --
    gnuplot.tochild.write("exit\n")
    
    
    gnuplot_output=gnuplot.fromchild.readlines()

    #--- to see gnuplot errors
    print "--- Gnuplot messages ----"
    print string.join(gnuplot_output,"")
    print "--- End of Gnuplot messages ----"
    
    variables={}
    #--- Looking now for a keyword followed by a value ---
    try:
        for keyword in keywords:
            linenum=mylib.Find_Keyword_First_in_String(gnuplot_output,"<<<"+keyword+">>>")
            if linenum==-1: raise IndexError
            words=gnuplot_output[linenum].split()
            #-- does it contain value after a keyword?
            if len(words)>1:
                variables[keyword]=float(words[1])
                continue
            else:
                raise ValueError
    

    except:
        #-- All gone bad. Exit. --
        #-- dump gnuplot output ---
        print"\n\nError occured when running gnuplot.  Check 'gnuplot.dump.txt'\n\n"
        dump=open('gnuplot.dump.txt','w')
        dump.write(string.join(gnuplot_output,''))
        dump.close()
        sys.exit()
    
                
    return variables

if __name__=="__main__" :

    commands="""
set term png size 1048,768
set output 'test.png'
set size 1,1
set title "Gnuplot run test"
set xlabel "Time, s"
set ylabel "Relative intensity"

set fit errorvariables
I0=500000
R=100
offset=100

f(x)=I0*exp(-R*x)+offset
fit f(x) 'run_gnuplot_test.dat' using 1:2:3 via I0,R,offset
plot f(x) with lines , 'run_gnuplot_test.dat' using 1:2:3 with errorbars




"""
    print gnuplot(commands,"R R_err")
























