#!/usr/bin/env python2
doc="""============== Separation of J_calc output ========================

The program separates 'J_calc_v1.2.py' output into three lists:

J_calc.selected.out.txt - corresponding to the residues of interest

J_calc.overlaps.out.txt - corresponding to overlapped residues

J_calc.control.out.txt - what is left from residue lists

----------

Usage: separate_J_calc_output.py J_calc_output_file.txt selected.list overlapped.list


==============================================================================

"""
import os,sys,string
import residues, textfile


#--- Correct number of arguments? ---
if len(sys.argv)!=4 :
    print doc
    sys.exit()

#---- Check if files exist ----
for fname in sys.argv[1:]:
    if not os.path.isfile(fname):
        print "\n\n\nError! File '%s' doesn't exist!\n\n" % fname


J_calc_output=textfile.Text_File(sys.argv[1])
selected=residues.Annn_Text(sys.argv[2])
overlapped=residues.Annn_Text(sys.argv[3])


#--- Find J constants values ---
J_constants_start=J_calc_output.find_keyword_first_in_line('Processing:')
J=J_calc_output.file[J_constants_start+2:]

sel_file=open('J_calc.selected.out.txt','w')
ovl_file=open('J_calc.overlaps.out.txt','w')
ctrl_file=open('J_calc.control.out.txt','w')

for line in J:
    words=line.split()
    #-- skip empty line --
    if len(words)==0: continue
    resname=words[0]
    #--- remove overlapped first ---
    if resname in overlapped.get_keys():
        ovl_file.write(line)
        continue
    else:
        #--- write out selected ---
        if resname in selected.get_keys():
            sel_file.write(line)
            continue
    #--- write out control group ---
    ctrl_file.write(line)

sel_file.close()
ovl_file.close()
ctrl_file.close()
print "Done."

    
    

