#!/usr/bin/env python
import string,  glob, os, sys
doc="""===== convert aminoacid sequence into a list of residues ====
by Evgenii Kovrgin,
Medical College of Wisconsin
3/11/09

Usage:
sequence2list.py singleAAcode_file.txt first_residue_number > your_output_fname.txt

        singleAAcode_file.txt is file with amino acid sequence like: 
                                 mteyklvvvg aggvgksalt iqliqnhfvd eydptiedsy rkqvvidget clldildtag
                                  qeeysamrdq ymr

        Any NON-LETTER symbols are ignored so residue numbers are permitted. 
        Make sure there are no text comments in this file!
"""


if len(sys.argv)<3:
    print doc
    sys.exit()

    
sequence_fname=sys.argv[1]

finp=open(sequence_fname,'r')
outfname=sequence_fname+'.list'
foutp=open(outfname,'w')

residues=finp.read()


#-- make an new HTML row
print "Converting:"

counter=int(sys.argv[2])
output=''
for symbol in residues:
  if symbol not in string.letters: continue
  
  line= "%s%d\n" % (string.upper(symbol), counter)
  output+=line
  print  "%s =>   %s%d\n" % (symbol, string.upper(symbol), counter)
   
  counter+=1
  
  
foutp.write(output)
  
finp.close()
foutp.close()

print '\n"%s" written.\n' % outfname
  
  
  
  
  
  
  
  
  
  
  
  































