#!/usr/bin/env python
#------ Check statistics 'Palmer' statistics vs Gaussian simulation-------------
import random
import time
from histograms import *
from math import sqrt

#---------- determine sigma squared of a normal distribution ---
def sigma_squared(distr_func, par_list, number_of_points=100000) :
    sum=0
    sumsquare=0
    for i in range(number_of_points) :
        x=apply(distr_func,par_list)
        sum=sum+x
        sumsquare=sumsquare+x*x
        if not i%20000 : print i, "numbers"
    return ((sumsquare-sum*sum/number_of_points)/number_of_points)


# ------- determine 'sigma' by the Palmer trick ------
def palmer_sigma_squared(mean,gauss_sigma, number_of_points=100000):
    delta_sum=0
    sigma=0
    N=number_of_points/2
    delta_list=[]

    for i in range(N):
        # generate two random numbers
        x1=random.gauss(mean,gauss_sigma)
        random.jumpahead(10)
        x2=random.gauss(mean,gauss_sigma)
        #calculate
        delta=x1-x2
        delta_list.append(delta)
        delta_sum=delta_sum+delta
        if not i%10000 : print i*2, "numbers"

    delta_mean=delta_sum/N
    print delta_mean
    for i in delta_list:
        sigma=sigma+(delta_mean-i)*(delta_mean-i)
    
    return  sigma/(N-1)
 


print "\nTest statistics: mean=10, sigma=1"
#--- gaussian distribution ----

repeats=500000
mean=0
sigma=1
print "Gauss---"
#gauss_sigma=sigma_squared(random.gauss,[0,1],repeats)
print "Palmer----"
palmer_sigma=palmer_sigma_squared(0,1,repeats)/2

print "Gauss sigma=", gauss_sigma
print "Palmer sigma=", palmer_sigma

##
##    x=random.gauss(mean, sigma)
##    x1=random.gauss(mean,gauss_sigma)
##    random.jumpahead(10)
##    x2=random.gauss(mean,gauss_sigma)
##    x=(x1-x2)/2


##repeats=1e5   
##print "Test of histogram"
##random.seed(time.time())
##x=[]
##for i in range(repeats):
##    # test: evenly distributed random num
##    #x.append(2*random.random()-1)
##
##    # Gaussian
##    #x.append(random.gauss(0,1))
##
##    # Gaussian x1-x2
##    #x.append(random.gauss(0,1)-random.gauss(0,1))
##
##    # Gaussian |x1-x2|
##    x.append(abs(random.gauss(0,1)-random.gauss(0,1)))
###out=open("Gauss.hist","w")
###out=open("diff.hist","w")
##out=open("abs_diff.hist","w")
##hist=histogram(x,5,100)
##
##for i in range(len(hist[0])):
##    out.write("%s\t%s\n" %(hist[0][i],hist[1][i]))
##       
##
##out.close()
##print "Done..."   


