#!/usr/bin/env python
import os,sys,string
import residues, xmgr
import mylib
import keyfile
import copy
import colors
from colors import *
#-- to make it portable: use color only when requested explicitly
if '-color' in sys.argv: colors.COLOR=ON

doc= """
**************************************************
'trim_mean_sigma.py column_to_evaluate dataset.dat [-color]'

    - column_to_evaluate - the actual column number (usu 2 if 1st - res name)
    - the data from 'column' are trimmed 10% and their mean and rmsd are calculated


**************************************************
"""

if len(sys.argv)<3 :
    print doc
    sys.exit()


data_fname=sys.argv[2]

VALUE_COLUMN=int(sys.argv[1])-2  # column in the datafile to average

SILENT,VERBOSE=0,1
ini_data=residues.Annn_Num(data_fname,mode=VERBOSE,header_lines=0)



full_data=copy.deepcopy(ini_data)
print full_data
trimmed_data=ini_data.trim_data(VALUE_COLUMN,10)

full_mean,full_sigma=full_data.statistics(column_number=0)
trimmed_mean,trimmed_sigma=trimmed_data.statistics(column_number=0)

print "*"*60
cprint(INV, "Dataset: %s" % data_fname)
print "Full mean: %.4f,  sigma   %.4f" % (full_mean,full_sigma)

trmean="%.4f," % trimmed_mean
trsigma="%.4f\n" % trimmed_sigma
print clr(INV,"Trimmed mean: "), clr(GREEN,trmean),"\tsigma ", clr(RED,trsigma)

open(data_fname+".trimmed",'w').write(
    "Source file: %s\nMean: %.4f,  Sigma   %.4f\n%s" %
    (data_fname,trimmed_mean,trimmed_sigma,trimmed_data))
                      

#------------- presentation -------------

full=xmgr.Dataset(full_data.to_xmgr("ResNum",0), "all")
full.circle()
full.empty_sym()
full.symbol_size(2.2)


trimmed=xmgr.Dataset(trimmed_data.to_xmgr("ResNum",0), "trimmed")
trimmed.circle()
trimmed.filled_sym()
trimmed.symbol_size(1)



graph=xmgr.Graph(data_fname,"Trimmed mean: %.4f,  Sigma   %.4f" %
                 (trimmed_mean,trimmed_sigma) )
graph.add_dataset(full)
graph.add_dataset(trimmed)
graph.set_xaxis("Residue number", 0, 125)
graph.set_yaxis("value", 0.3, 1)
graph.writeout(data_fname+".xmgr")


                      



