#!/usr/bin/env python
import os, sys, string, glob, mylib
doc="""
============ Unscrew Sparky Savefiles by Evgenii Kovrigin ====
Run this is the program to 'unscrew' paths in the Sparky .save files
in the current directory and make them and the project movable 
(it REPLACES the path written into .save files by Sparky which
prevents opening these files after they were moved to another location).
The program also removes unnecessary pathnames from filenames in the
project files if they are found in the same directory.

Usage:
unscrew_savefiles.py path_to_sp_files

path_to_sp_files - (usually ../ if you used make_sp_files.py )

================================================================
"""


if len(sys.argv)!=2:
    print doc
    sys.exit()




#-- fix paths in Sparky files
save_files=glob.glob('*.save')
for file in save_files:
    text=mylib.Load_Text_File(file)
    pathlinenum=mylib.Find_String_Num(text,'pathname')
    fname=os.path.basename(text[pathlinenum].split()[1])
    newline='pathname '+sys.argv[1]+fname+'\n'
    text[pathlinenum]=newline
    mylib.Write_Text_File(text,file)
    print "Save '%s' - fixed " % file

#---- fix paths in the Project files
proj_files=glob.glob('*.proj')
for file in proj_files:
    text=mylib.Load_Text_File(file)
    first_fname=mylib.Find_String_Num(text,'<savefiles>')+1
    last_fname=mylib.Find_String_Num(text,'savefiles>')
    for count in range(first_fname,last_fname,1):
        bare_fname=os.path.basename(text[count])
        text[count]=bare_fname
    mylib.Write_Text_File(text,file)
    print "Project file: '%s' - fixed " % file
    
