#!/usr/bin/env python
import  sys, os, string, time, copy

#-- field in stat output corresponding to last access unix time
LAST_ACCESS_STAT_FIELD =8

def current_time():
    '-> (weekday, month, date, time, zone,year)'
    ostime=os.popen("date")
    mytime=ostime.readline().split()
    return mytime

def last_access_time(fname):
    'returns time of last access to afile'
    stat_result=os.stat(fname)
    #sprint stat_result
    #-- fields in UNIX stat result corresponding to current and access times

    last_access=stat_result[LAST_ACCESS_STAT_FIELD]
    
    return last_access

from smtplib import *
def email(sender, recipient, email_server,  message):
        'sends an email'
        try:
            server=SMTP(email_server)
            failed=server.sendmail("%s" % sender, recipient, message)
            server.quit()
        except:
            open("failed_email.log",'a').write("%s: Exceptions raised on sending a message to '%s'\nMessage text: %s\n"
                                                    % (current_time(),email_server, message))
            return
        
        if failed:
            open("failed_email.log",'a').write("%s: Address failed on sending a message to '%s'\nMessage text: %s\n"
                                        % (current_time(), email_server, message))
#-------------- the program --------------


version='1.1  8/11/08'
email_server='smtp.mcw.edu'
sender='Bartok@biochemistry.mcw.edu'
recipient='ekovrig@mcw.edu'
stop_file_name='watch.stop' #-- create this file in the experimental folder to stop running program

experiment_path='/opt/topspin/data/kovrigin/nmr/ekn49.TXI_testing'
experiments=[ '12','13','14','15', '16', '17']

wait_time=60 # minutes



outstring="\n============== WATCH_BRUKER ========================="
outstring+="\nver.%s\nby Evgenii Kovrigin,\nMedical College of Wisconsin" % version
outstring+="\n\n Monitoring %s" % sender
outstring+="\nCurrent path: %s" % experiment_path
outstring+="\nExperiments: %s" % string.join(experiments, ' ')
outstring+="\nWaiting time between checks: %d min" % wait_time
outstring+="\nEmail report to: %s" % recipient
outstring+="\nStarting endless loop....\n"
outstring+="\nTo stop monitoring: create an empty file '%s' in the experiment folder" % stop_file_name
print outstring
email(sender, recipient, email_server,  outstring)

#--- analysis
Nexp=len(experiments)
old_access_times=[]
first_access_times=[]

while 1>0: # endless loop
#for repeat in range(3): #  short loop for development
 
  #--- get new accesstimes
  access_times=[]
  for cur_exp in experiments:
    cur_exp_ser=os.path.join(experiment_path,cur_exp,'ser')  #--  all 2D
    cur_exp_fid=os.path.join(experiment_path,cur_exp,'fid')  #--- all 1D
   
    if os.path.isfile(cur_exp_ser):
       fname=cur_exp_ser
    else:
      if os.path.isfile(cur_exp_fid):
          fname=cur_exp_fid
      else:
          access_times.append(0)
          continue
          
    #-- add access
    print 'Checking ', fname
    access_times.append(last_access_time(fname))

  
  #--- skip the first pass
  if len(old_access_times)==0: 
    old_access_times=copy.copy(access_times)
    first_access_times=copy.copy(access_times)
    print "1st time"
    #--- wait
    time.sleep(wait_time*60)
    continue
  
  #-- analyze
  outstring='\n============== WATCH_BRUKER =========================\n%s\nExp   Status      (t(i-1) - Delay - t(i))\n'% os.popen('date').readline()
  for counter in range(Nexp):
    
    t0=old_access_times[counter]
    t1=access_times[counter]
    t_ini=first_access_times[counter]
    if t1 > t0: status='RUNNING'
    if t1 == t0: 
        if t1 > t_ini:
            status='finished'
        else:
            status='waiting'
            
    if t1 == 0: status='fid or ser file missing'
    
    outstring+='#%s - %s  (%d   -  %d min -  %d sec)\n' % (experiments[counter], status, t0,wait_time,t1)
  
  print outstring
  email(sender, recipient, email_server,  outstring)
   
  if(os.path.isfile(os.path.join(experiment_path,stop_file_name))): 
    outstring="\n============== WATCH_BRUKER =========================\nExit requested. Before restarting the program make sure to delete '%s'." % stop_file_name
    print outstring
    email(sender, recipient, email_server,  outstring)
    break
  #--- wait
  time.sleep(wait_time*60)
  old_access_times=copy.copy(access_times)
  

 
  
