#!/usr/bin/env python
import sys
doc=""" Chemical shift of water at pH 5.5
 Ref: Cavanaugh et all, Protein NMR spectroscopy, p.237
 
Usage: water_shift.py temp_Celcius
"""

if len(sys.argv)<2:
    print doc
    sys.exit()

temp=float(sys.argv[1])
T= 273.2+temp # Kelvin


print "Calculation of water chemical shift"

water=7.83-T/96.9

print "Temperature: %.3f K (%.3f C)" % (T, temp)
print "Water chemical shift at pH 5.5: %.3f ppm\n" % water
